# Routes ## List Routes `client.MagicTransit.Routes.List(ctx, query) (*RouteListResponse, error)` **get** `/accounts/{account_id}/magic/routes` List all Magic static routes. ### Parameters - `query RouteListParams` - `AccountID param.Field[string]` Identifier ### Returns - `type RouteListResponse struct{…}` - `Routes []RouteListResponseRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) routes, err := client.MagicTransit.Routes.List(context.TODO(), magic_transit.RouteListParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", routes.Routes) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "routes": [ { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } ] }, "success": true } ``` ## Route Details `client.MagicTransit.Routes.Get(ctx, routeID, query) (*RouteGetResponse, error)` **get** `/accounts/{account_id}/magic/routes/{route_id}` Get a specific Magic static route. ### Parameters - `routeID string` Identifier - `query RouteGetParams` - `AccountID param.Field[string]` Identifier ### Returns - `type RouteGetResponse struct{…}` - `Route RouteGetResponseRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) route, err := client.MagicTransit.Routes.Get( context.TODO(), "023e105f4ecef8ad9ca31a8372d0c353", magic_transit.RouteGetParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", route.Route) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "route": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } }, "success": true } ``` ## Create a Route `client.MagicTransit.Routes.New(ctx, params) (*RouteNewResponse, error)` **post** `/accounts/{account_id}/magic/routes` Creates a new Magic static route. Use `?validate_only=true` as an optional query parameter to run validation only without persisting changes. ### Parameters - `params RouteNewParams` - `AccountID param.Field[string]` Path param: Identifier - `Nexthop param.Field[string]` Body param: The next-hop IP Address for the static route. - `Prefix param.Field[string]` Body param: IP Prefix in Classless Inter-Domain Routing format. - `Priority param.Field[int64]` Body param: Priority of the static route. - `Description param.Field[string]` Body param: An optional human provided description of the static route. - `Scope param.Field[Scope]` Body param: Used only for ECMP routes. - `Weight param.Field[int64]` Body param: Optional weight of the ECMP scope - if provided. ### Returns - `type RouteNewResponse struct{…}` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) route, err := client.MagicTransit.Routes.New(context.TODO(), magic_transit.RouteNewParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Nexthop: cloudflare.F("203.0.113.1"), Prefix: cloudflare.F("192.0.2.0/24"), Priority: cloudflare.F(int64(0)), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", route.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 }, "success": true } ``` ## Update Route `client.MagicTransit.Routes.Update(ctx, routeID, params) (*RouteUpdateResponse, error)` **put** `/accounts/{account_id}/magic/routes/{route_id}` Update a specific Magic static route. Use `?validate_only=true` as an optional query parameter to run validation only without persisting changes. ### Parameters - `routeID string` Identifier - `params RouteUpdateParams` - `AccountID param.Field[string]` Path param: Identifier - `Nexthop param.Field[string]` Body param: The next-hop IP Address for the static route. - `Prefix param.Field[string]` Body param: IP Prefix in Classless Inter-Domain Routing format. - `Priority param.Field[int64]` Body param: Priority of the static route. - `Description param.Field[string]` Body param: An optional human provided description of the static route. - `Scope param.Field[Scope]` Body param: Used only for ECMP routes. - `Weight param.Field[int64]` Body param: Optional weight of the ECMP scope - if provided. ### Returns - `type RouteUpdateResponse struct{…}` - `Modified bool` - `ModifiedRoute RouteUpdateResponseModifiedRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) route, err := client.MagicTransit.Routes.Update( context.TODO(), "023e105f4ecef8ad9ca31a8372d0c353", magic_transit.RouteUpdateParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Nexthop: cloudflare.F("203.0.113.1"), Prefix: cloudflare.F("192.0.2.0/24"), Priority: cloudflare.F(int64(0)), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", route.Modified) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "modified": true, "modified_route": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } }, "success": true } ``` ## Delete Route `client.MagicTransit.Routes.Delete(ctx, routeID, body) (*RouteDeleteResponse, error)` **delete** `/accounts/{account_id}/magic/routes/{route_id}` Disable and remove a specific Magic static route. ### Parameters - `routeID string` Identifier - `body RouteDeleteParams` - `AccountID param.Field[string]` Identifier ### Returns - `type RouteDeleteResponse struct{…}` - `Deleted bool` - `DeletedRoute RouteDeleteResponseDeletedRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) route, err := client.MagicTransit.Routes.Delete( context.TODO(), "023e105f4ecef8ad9ca31a8372d0c353", magic_transit.RouteDeleteParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", route.Deleted) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "deleted": true, "deleted_route": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } }, "success": true } ``` ## Update Many Routes `client.MagicTransit.Routes.BulkUpdate(ctx, params) (*RouteBulkUpdateResponse, error)` **put** `/accounts/{account_id}/magic/routes` Update multiple Magic static routes. Use `?validate_only=true` as an optional query parameter to run validation only without persisting changes. Only fields for a route that need to be changed need be provided. ### Parameters - `params RouteBulkUpdateParams` - `AccountID param.Field[string]` Path param: Identifier - `Routes param.Field[[]RouteBulkUpdateParamsRoute]` Body param - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `Description string` An optional human provided description of the static route. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Returns - `type RouteBulkUpdateResponse struct{…}` - `Modified bool` - `ModifiedRoutes []RouteBulkUpdateResponseModifiedRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) response, err := client.MagicTransit.Routes.BulkUpdate(context.TODO(), magic_transit.RouteBulkUpdateParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Routes: cloudflare.F([]magic_transit.RouteBulkUpdateParamsRoute{magic_transit.RouteBulkUpdateParamsRoute{ ID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Nexthop: cloudflare.F("203.0.113.1"), Prefix: cloudflare.F("192.0.2.0/24"), Priority: cloudflare.F(int64(0)), }}), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response.Modified) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "modified": true, "modified_routes": [ { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } ] }, "success": true } ``` ## Delete Many Routes `client.MagicTransit.Routes.Empty(ctx, body) (*RouteEmptyResponse, error)` **delete** `/accounts/{account_id}/magic/routes` Delete multiple Magic static routes. ### Parameters - `body RouteEmptyParams` - `AccountID param.Field[string]` Identifier ### Returns - `type RouteEmptyResponse struct{…}` - `Deleted bool` - `DeletedRoutes []RouteEmptyResponseDeletedRoute` - `ID string` Identifier - `Nexthop string` The next-hop IP Address for the static route. - `Prefix string` IP Prefix in Classless Inter-Domain Routing format. - `Priority int64` Priority of the static route. - `CreatedOn Time` When the route was created. - `Description string` An optional human provided description of the static route. - `ModifiedOn Time` When the route was last modified. - `Scope Scope` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope. - `Weight int64` Optional weight of the ECMP scope - if provided. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/magic_transit" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) response, err := client.MagicTransit.Routes.Empty(context.TODO(), magic_transit.RouteEmptyParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response.Deleted) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "deleted": true, "deleted_routes": [ { "id": "023e105f4ecef8ad9ca31a8372d0c353", "nexthop": "203.0.113.1", "prefix": "192.0.2.0/24", "priority": 0, "created_on": "2017-06-14T00:00:00Z", "description": "New route for new prefix 203.0.113.1", "modified_on": "2017-06-14T05:20:00Z", "scope": { "colo_names": [ "den01" ], "colo_regions": [ "APAC" ] }, "weight": 0 } ] }, "success": true } ``` ## Domain Types ### Scope - `type Scope struct{…}` Used only for ECMP routes. - `ColoNames []string` List of colo names for the ECMP scope. - `ColoRegions []string` List of colo regions for the ECMP scope.